//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4A9D598900B8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4A9D598900B8.cm

//## begin module%4A9D598900B8.cp preserve=no
//## end module%4A9D598900B8.cp

//## Module: PlotSettings%4A9D598900B8; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotSettings.h

#ifndef PLOTSETTINGS_H
#define PLOTSETTINGS_H 1

//## begin module%4A9D598900B8.additionalIncludes preserve=no
//## end module%4A9D598900B8.additionalIncludes

//## begin module%4A9D598900B8.includes preserve=yes
//## end module%4A9D598900B8.includes

//## begin module%4A9D598900B8.declarations preserve=no
//## end module%4A9D598900B8.declarations

//## begin module%4A9D598900B8.additionalDeclarations preserve=yes
#include <xsTypes.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>
#include <list>
#include <utility>
//## end module%4A9D598900B8.additionalDeclarations


//## begin PlotSettings%4A9D5A2C005E.preface preserve=yes
//## end PlotSettings%4A9D5A2C005E.preface

//## Class: PlotSettings%4A9D5A2C005E
//	An aggregate class of PlotDirector, this is intended to
//	hold the various settings input from the setplot command.
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class PlotSettings 
{
  //## begin PlotSettings%4A9D5A2C005E.initialDeclarations preserve=yes
  //## end PlotSettings%4A9D5A2C005E.initialDeclarations

  public:
    //## Class: PlotErrMode%4A9FE5C40136
    //## Category: XSPlot::Plot%3D625E6A0065
    //## Subsystem: XSPlot::Plot%3D625E94026B
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {STD,ROOTN,GEHRELS1,GEHRELS2,GEHRELSM} PlotErrMode;

    //## Class: RebinInfo%4A9FE673018B
    //## Category: XSPlot::Plot%3D625E6A0065
    //## Subsystem: XSPlot::Plot%3D625E94026B
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct RebinInfo 
    {
        // Data Members for Class Attributes

          //## Attribute: sigma%4A9FE69F0198
          //## begin PlotSettings::RebinInfo::sigma%4A9FE69F0198.attr preserve=no  public: Real {U} 
          Real sigma;
          //## end PlotSettings::RebinInfo::sigma%4A9FE69F0198.attr

          //## Attribute: maxBins%4A9FE6AC01D4
          //## begin PlotSettings::RebinInfo::maxBins%4A9FE6AC01D4.attr preserve=no  public: int {U} 
          int maxBins;
          //## end PlotSettings::RebinInfo::maxBins%4A9FE6AC01D4.attr

          //## Attribute: mode%4A9FE6B302EC
          //## begin PlotSettings::RebinInfo::mode%4A9FE6B302EC.attr preserve=no  public: PlotSettings::PlotErrMode {U} 
          PlotSettings::PlotErrMode mode;
          //## end PlotSettings::RebinInfo::mode%4A9FE6B302EC.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Class: SaveArrayOption%4ACA16F00150
    //## Category: XSPlot::Plot%3D625E6A0065
    //## Subsystem: XSPlot::Plot%3D625E94026B
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {NO_SAVE, X_AR, XERR_AR, Y_AR, YERR_AR, MODEL_AR} SaveArrayOption;

    //## Constructors (generated)
      PlotSettings();

    //## Destructor (generated)
      ~PlotSettings();


    //## Other Operations (specified)
      //## Operation: setXOption%4A9D641C03D8
      void setXOption (const string& option);

      //## Operation: addUserCommand%4A9D690702C7
      int addUserCommand (const string& command);

      //## Operation: removeUserCommand%4A9D69FF01D7
      void removeUserCommand (int numCmd);

      //## Operation: setPlotGroupNums%4A9D6E0201D8
      void setPlotGroupNums (const string& rangesString);

      //## Operation: setIDs%4A9D71480306
      void setIDs (const std::vector<Real>& values);

      //## Operation: showUserCommands%4A9D72EA03D8
      void showUserCommands () const;

      //## Operation: ungroupAll%4A9FEBD40088
      void ungroupAll ();

      //## Operation: initializeSpectra%4AB8F47F0340
      void initializeSpectra ();

      //## Operation: groupsRebinInfo%4AC2153B0346
      const std::map<int,PlotSettings::RebinInfo>& groupsRebinInfo () const;

      //## Operation: setDivideByArea%4ADC8666022C
      //	whichFlag = 0 is for passing along the user's setplot
      //	setting.  = 1 passes along the PlotCommand attribute.
      void setDivideByArea (int whichFlag, bool value);

      //## Operation: setShowAddComponent%4ADC871B036F
      //	Sets the user-adjusted (from setplot command) show add
      //	component flag.
      void setShowAddComponent (bool value);

      //## Operation: setAddCompLevel%4B217EFE0111
      //	Sets the level of add comp display, as determined by the
      //	particular PlotCommand.
      void setAddCompLevel (int level);

      //## Operation: setShowBackground%4ADC874C039B
      void setShowBackground (int whichFlag, bool value);

      //## Operation: setShowLineIDs%4B5F474B024F
      void setShowLineIDs (int whichFlag, bool value);

      //## Operation: getDivideByArea%4B60C2E500C4
      //	Returns the value set with the "setplot area/noarea"
      //	options.
      bool getDivideByArea () const;

      //## Operation: getShowAddComponent%4B60C239021A
      //	Retrieves the value set with the "setplot add/noadd"
      //	options.
      bool getShowAddComponent () const;

      //## Operation: getShowBackground%4B60C345002C
      bool getShowBackground () const;

      //## Operation: getShowLineIDs%4B60C3670157
      bool getShowLineIDs () const;

      //## Operation: divideByArea%4ADC893500E8
      //	Returns the boolean combination of the user's setplot
      //	request and the PlotCommand's corresponding attribute.
      bool divideByArea () const;

      //## Operation: showAddComponent%4ADC89AC028D
      //	Indicates whether add components will actually be
      //	displayed, based on the information in the m_showAdd
      //	Component pair.
      bool showAddComponent () const;

      //## Operation: showFoldedAddComponent%4B21808203AB
      bool showFoldedAddComponent () const;

      //## Operation: showBackground%4ADC89B7009F
      bool showBackground () const;

      //## Operation: showLineIDs%4B5F48000204
      bool showLineIDs () const;

      //## Operation: getUnitID%4AFDB6120348
      const string& getUnitID (XaxisMode mode) const;

      //## Operation: getUnitPlotLabel%4AFDB686003D
      const string& getUnitPlotLabel (XaxisMode mode) const;

      //## Operation: getUnitFactor%4AFDB6C40335
      Real getUnitFactor (XaxisMode mode) const;

      //## Operation: makeXOptionDependentLabel%4B01C2FC035B
      //	Utility function for PlotCommands sharing the common
      //	Chan/Energ/Wave axis label dependency.  This fills an
      //	x-axis label based upon the current xOption setting and
      //	the units setting.  It also returns the x label key,
      //	which the PlotCommand may want to use for constructing a
      //	y-axis label.
      string makeXOptionDependentLabel (string& xLabel) const;

      //## Operation: insertUnitLabel%4B01C3C6037A
      //	Plot label utility function.  Any generic unit
      //	placeholder strings in plotLabel are replaced with the
      //	appropriate unit label based upon the current xOption
      //	and units settings.  If checkPerHz flag is true, it will
      //	also check the isWavePerHz setting when in wavelength
      //	mode.  Generally y labels will want this and x labels
      //	will not.
      void insertUnitLabel (string& plotLabel, bool checkPerHz) const;

      //## Operation: lookupLabelName%4B01D9E3020A
      //	Returns the plot label entry based on the labelKey.
      //	Throws if labelKey is not found in map.
      const string& lookupLabelName (const string& labelKey) const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: xOption%4A9D634A01CF
      XaxisMode xOption () const;
      void xOption (XaxisMode value);

      //## Attribute: userCommands%4A9D6899013B
      const std::list<string>& userCommands () const;

      //## Attribute: temperature%4A9D704C03A5
      Real temperature () const;

      //## Attribute: emisLimit%4A9D70590337
      Real emisLimit () const;

      //## Attribute: redshiftLinesToObs%4A9D706302BF
      //	This is the Z = V/C value used to shift line IDs from
      //	the source to obs frame.  It is set through the "setplot
      //	id" option.
      Real redshiftLinesToObs () const;

      //## Attribute: redshiftToSource%4B7DC5EE0254
      //	This is the Z = V/C value used to shift the x-axis
      //	energy/wavelength values from the obs frame to the
      //	source frame.  Set using "setplot redshift", separate
      //	from the "setplot id" redshift value.
      Real redshiftToSource () const;
      void redshiftToSource (Real value);

      //## Attribute: groupsRebinInfo%4A9FE9A80253
      std::map<int,PlotSettings::RebinInfo>& groupsRebinInfo ();

      //## Attribute: lastRebinEntry%4A9FEA0D0055
      std::pair<int,PlotSettings::RebinInfo>& lastRebinEntry ();

      //## Attribute: splashPage%4A9FEB1601B9
      bool splashPage () const;
      void splashPage (bool value);

      //## Attribute: xLog%4A9FECC9037F
      bool xLog () const;
      void xLog (bool value);

      //## Attribute: yLog%4A9FECD203D0
      bool yLog () const;
      void yLog (bool value);

      //## Attribute: energyUnit%4AFDB29B0245
      //	Stores 3 fields of information: the unit ID string as
      //	entered through setplot, the unit as it appears in a
      //	plot label, and the conversion factor.
      void energyUnit (const std::pair<string,std::pair<string,Real> >& value);

      //## Attribute: waveUnit%4AFDB3340173
      void waveUnit (const std::pair<string,std::pair<string,Real> >& value);

      //## Attribute: isWavePerHz%4B75BEF30309
      //	If true, wavelength mode y-axis values will be presented
      //	per Hz rather than per length unit (where applicable).
      bool isWavePerHz () const;
      void isWavePerHz (bool value);

      //## Attribute: spectra%4AB8F3F102AB
      //	Pointers to spectra, collated by plot group number.
      const SpecGroup& spectra () const;

      //## Attribute: isInteractive%4AC67325017F
      bool isInteractive () const;
      void isInteractive (bool value);

      //## Attribute: saveArrayInfo%4ACA177B01BF
      const std::pair<PlotSettings::SaveArrayOption, int> saveArrayInfo () const;
      void saveArrayInfo (std::pair<PlotSettings::SaveArrayOption, int> value);

      //## Attribute: labelNames%4B01D6FD0330
      //	This is where the plotLabel.dat entries are stored.  It
      //	is publicly modifiable so that PlotDirector may set it
      //	from its loading function.
      std::map<string,string>& labelNames ();

      //## Attribute: badDataValue%4B1D57FE0236
      //	This ought to originate with the specific PlotPkg class.
      //	The plot director should fill this in based on that.
      Real badDataValue () const;
      void badDataValue (Real value);

  public:
    // Additional Public Declarations
      //## begin PlotSettings%4A9D5A2C005E.public preserve=yes
      //## end PlotSettings%4A9D5A2C005E.public

  protected:
    // Additional Protected Declarations
      //## begin PlotSettings%4A9D5A2C005E.protected preserve=yes
      //## end PlotSettings%4A9D5A2C005E.protected

  private:
    //## Constructors (generated)
      PlotSettings(const PlotSettings &right);

    //## Assignment Operation (generated)
      PlotSettings & operator=(const PlotSettings &right);

    // Additional Private Declarations
      //## begin PlotSettings%4A9D5A2C005E.private preserve=yes
      //## end PlotSettings%4A9D5A2C005E.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin PlotSettings::xOption%4A9D634A01CF.attr preserve=no  public: XaxisMode {U} 
      XaxisMode m_xOption;
      //## end PlotSettings::xOption%4A9D634A01CF.attr

      //## begin PlotSettings::userCommands%4A9D6899013B.attr preserve=no  public: std::list<string> {U} 
      std::list<string> m_userCommands;
      //## end PlotSettings::userCommands%4A9D6899013B.attr

      //## Attribute: prevGroupRange%4A9D6D7D0149
      //## begin PlotSettings::prevGroupRange%4A9D6D7D0149.attr preserve=no  private: std::pair<size_t,size_t> {U} 
      std::pair<size_t,size_t> m_prevGroupRange;
      //## end PlotSettings::prevGroupRange%4A9D6D7D0149.attr

      //## begin PlotSettings::temperature%4A9D704C03A5.attr preserve=no  public: Real {U} 
      Real m_temperature;
      //## end PlotSettings::temperature%4A9D704C03A5.attr

      //## begin PlotSettings::emisLimit%4A9D70590337.attr preserve=no  public: Real {U} 
      Real m_emisLimit;
      //## end PlotSettings::emisLimit%4A9D70590337.attr

      //## begin PlotSettings::redshiftLinesToObs%4A9D706302BF.attr preserve=no  public: Real {U} 
      Real m_redshiftLinesToObs;
      //## end PlotSettings::redshiftLinesToObs%4A9D706302BF.attr

      //## begin PlotSettings::redshiftToSource%4B7DC5EE0254.attr preserve=no  public: Real {U} 
      Real m_redshiftToSource;
      //## end PlotSettings::redshiftToSource%4B7DC5EE0254.attr

      //## begin PlotSettings::groupsRebinInfo%4A9FE9A80253.attr preserve=no  public: std::map<int,PlotSettings::RebinInfo> {U} 
      std::map<int,PlotSettings::RebinInfo> m_groupsRebinInfo;
      //## end PlotSettings::groupsRebinInfo%4A9FE9A80253.attr

      //## begin PlotSettings::lastRebinEntry%4A9FEA0D0055.attr preserve=no  public: std::pair<int,PlotSettings::RebinInfo> {U} 
      std::pair<int,PlotSettings::RebinInfo> m_lastRebinEntry;
      //## end PlotSettings::lastRebinEntry%4A9FEA0D0055.attr

      //## begin PlotSettings::splashPage%4A9FEB1601B9.attr preserve=no  public: bool {U} 
      bool m_splashPage;
      //## end PlotSettings::splashPage%4A9FEB1601B9.attr

      //## begin PlotSettings::xLog%4A9FECC9037F.attr preserve=no  public: bool {U} 
      bool m_xLog;
      //## end PlotSettings::xLog%4A9FECC9037F.attr

      //## begin PlotSettings::yLog%4A9FECD203D0.attr preserve=no  public: bool {U} 
      bool m_yLog;
      //## end PlotSettings::yLog%4A9FECD203D0.attr

      //## begin PlotSettings::energyUnit%4AFDB29B0245.attr preserve=no  public: std::pair<string,std::pair<string,Real> > {U} 
      std::pair<string,std::pair<string,Real> > m_energyUnit;
      //## end PlotSettings::energyUnit%4AFDB29B0245.attr

      //## begin PlotSettings::waveUnit%4AFDB3340173.attr preserve=no  public: std::pair<string,std::pair<string,Real> > {U} 
      std::pair<string,std::pair<string,Real> > m_waveUnit;
      //## end PlotSettings::waveUnit%4AFDB3340173.attr

      //## begin PlotSettings::isWavePerHz%4B75BEF30309.attr preserve=no  public: bool {U} 
      bool m_isWavePerHz;
      //## end PlotSettings::isWavePerHz%4B75BEF30309.attr

      //## Attribute: divideByArea%4A9FEDAF035F
      //	The first flag is set by the user through setplot.  The
      //	second is determined by the particular plot command.
      //## begin PlotSettings::divideByArea%4A9FEDAF035F.attr preserve=no  public: std::pair<bool,bool> {U} 
      std::pair<bool,bool> m_divideByArea;
      //## end PlotSettings::divideByArea%4A9FEDAF035F.attr

      //## Attribute: showAddComponent%4ADC82560189
      //	Pair's first member is for storing the user adjusted
      //	"setplot add/noadd" flag.  The second is for storing the
      //	most recent PlotCommand's addCompLevel.
      //## begin PlotSettings::showAddComponent%4ADC82560189.attr preserve=no  public: std::pair<bool,int> {U} 
      std::pair<bool,int> m_showAddComponent;
      //## end PlotSettings::showAddComponent%4ADC82560189.attr

      //## Attribute: showBackground%4ADC83820064
      //## begin PlotSettings::showBackground%4ADC83820064.attr preserve=no  public: std::pair<bool,bool> {U} 
      std::pair<bool,bool> m_showBackground;
      //## end PlotSettings::showBackground%4ADC83820064.attr

      //## Attribute: showLineIDs%4B5F46DA01AE
      //## begin PlotSettings::showLineIDs%4B5F46DA01AE.attr preserve=no  public: std::pair<bool,bool> {U} 
      std::pair<bool,bool> m_showLineIDs;
      //## end PlotSettings::showLineIDs%4B5F46DA01AE.attr

      //## begin PlotSettings::spectra%4AB8F3F102AB.attr preserve=no  public: SpecGroup {U} 
      SpecGroup m_spectra;
      //## end PlotSettings::spectra%4AB8F3F102AB.attr

      //## begin PlotSettings::isInteractive%4AC67325017F.attr preserve=no  public: bool {U} 
      bool m_isInteractive;
      //## end PlotSettings::isInteractive%4AC67325017F.attr

      //## begin PlotSettings::saveArrayInfo%4ACA177B01BF.attr preserve=no  public: std::pair<PlotSettings::SaveArrayOption, int> {U} 
      std::pair<PlotSettings::SaveArrayOption, int> m_saveArrayInfo;
      //## end PlotSettings::saveArrayInfo%4ACA177B01BF.attr

      //## begin PlotSettings::labelNames%4B01D6FD0330.attr preserve=no  public: std::map<string,string> {U} 
      std::map<string,string> m_labelNames;
      //## end PlotSettings::labelNames%4B01D6FD0330.attr

      //## begin PlotSettings::badDataValue%4B1D57FE0236.attr preserve=no  public: Real {U} 
      Real m_badDataValue;
      //## end PlotSettings::badDataValue%4B1D57FE0236.attr

    // Additional Implementation Declarations
      //## begin PlotSettings%4A9D5A2C005E.implementation preserve=yes
      //## end PlotSettings%4A9D5A2C005E.implementation

};

//## begin PlotSettings%4A9D5A2C005E.postscript preserve=yes
//## end PlotSettings%4A9D5A2C005E.postscript

// Class PlotSettings::RebinInfo 

// Class PlotSettings 


//## Other Operations (inline)
inline const std::map<int,PlotSettings::RebinInfo>& PlotSettings::groupsRebinInfo () const
{
  //## begin PlotSettings::groupsRebinInfo%4AC2153B0346.body preserve=yes
   return m_groupsRebinInfo;
  //## end PlotSettings::groupsRebinInfo%4AC2153B0346.body
}

inline void PlotSettings::setDivideByArea (int whichFlag, bool value)
{
  //## begin PlotSettings::setDivideByArea%4ADC8666022C.body preserve=yes
   whichFlag ? m_divideByArea.second = value : m_divideByArea.first = value;
  //## end PlotSettings::setDivideByArea%4ADC8666022C.body
}

inline void PlotSettings::setShowAddComponent (bool value)
{
  //## begin PlotSettings::setShowAddComponent%4ADC871B036F.body preserve=yes
   m_showAddComponent.first = value;
  //## end PlotSettings::setShowAddComponent%4ADC871B036F.body
}

inline void PlotSettings::setAddCompLevel (int level)
{
  //## begin PlotSettings::setAddCompLevel%4B217EFE0111.body preserve=yes
   m_showAddComponent.second = level;
  //## end PlotSettings::setAddCompLevel%4B217EFE0111.body
}

inline void PlotSettings::setShowBackground (int whichFlag, bool value)
{
  //## begin PlotSettings::setShowBackground%4ADC874C039B.body preserve=yes
   whichFlag ? m_showBackground.second = value : m_showBackground.first = value;
  //## end PlotSettings::setShowBackground%4ADC874C039B.body
}

inline void PlotSettings::setShowLineIDs (int whichFlag, bool value)
{
  //## begin PlotSettings::setShowLineIDs%4B5F474B024F.body preserve=yes
   whichFlag ? m_showLineIDs.second = value : m_showLineIDs.first = value;
  //## end PlotSettings::setShowLineIDs%4B5F474B024F.body
}

inline bool PlotSettings::getDivideByArea () const
{
  //## begin PlotSettings::getDivideByArea%4B60C2E500C4.body preserve=yes
   return m_divideByArea.first;
  //## end PlotSettings::getDivideByArea%4B60C2E500C4.body
}

inline bool PlotSettings::getShowAddComponent () const
{
  //## begin PlotSettings::getShowAddComponent%4B60C239021A.body preserve=yes
   return m_showAddComponent.first;
  //## end PlotSettings::getShowAddComponent%4B60C239021A.body
}

inline bool PlotSettings::getShowBackground () const
{
  //## begin PlotSettings::getShowBackground%4B60C345002C.body preserve=yes
   return m_showBackground.first;
  //## end PlotSettings::getShowBackground%4B60C345002C.body
}

inline bool PlotSettings::getShowLineIDs () const
{
  //## begin PlotSettings::getShowLineIDs%4B60C3670157.body preserve=yes
   return m_showLineIDs.first;
  //## end PlotSettings::getShowLineIDs%4B60C3670157.body
}

inline bool PlotSettings::divideByArea () const
{
  //## begin PlotSettings::divideByArea%4ADC893500E8.body preserve=yes
   return m_divideByArea.first && m_divideByArea.second;
  //## end PlotSettings::divideByArea%4ADC893500E8.body
}

inline bool PlotSettings::showBackground () const
{
  //## begin PlotSettings::showBackground%4ADC89B7009F.body preserve=yes
   return m_showBackground.first && m_showBackground.second;
  //## end PlotSettings::showBackground%4ADC89B7009F.body
}

inline bool PlotSettings::showLineIDs () const
{
  //## begin PlotSettings::showLineIDs%4B5F48000204.body preserve=yes
   return m_showLineIDs.first && m_showLineIDs.second;
  //## end PlotSettings::showLineIDs%4B5F48000204.body
}

//## Get and Set Operations for Class Attributes (inline)

inline XaxisMode PlotSettings::xOption () const
{
  //## begin PlotSettings::xOption%4A9D634A01CF.get preserve=no
  return m_xOption;
  //## end PlotSettings::xOption%4A9D634A01CF.get
}

inline const std::list<string>& PlotSettings::userCommands () const
{
  //## begin PlotSettings::userCommands%4A9D6899013B.get preserve=no
  return m_userCommands;
  //## end PlotSettings::userCommands%4A9D6899013B.get
}

inline Real PlotSettings::temperature () const
{
  //## begin PlotSettings::temperature%4A9D704C03A5.get preserve=no
  return m_temperature;
  //## end PlotSettings::temperature%4A9D704C03A5.get
}

inline Real PlotSettings::emisLimit () const
{
  //## begin PlotSettings::emisLimit%4A9D70590337.get preserve=no
  return m_emisLimit;
  //## end PlotSettings::emisLimit%4A9D70590337.get
}

inline Real PlotSettings::redshiftLinesToObs () const
{
  //## begin PlotSettings::redshiftLinesToObs%4A9D706302BF.get preserve=no
  return m_redshiftLinesToObs;
  //## end PlotSettings::redshiftLinesToObs%4A9D706302BF.get
}

inline Real PlotSettings::redshiftToSource () const
{
  //## begin PlotSettings::redshiftToSource%4B7DC5EE0254.get preserve=no
  return m_redshiftToSource;
  //## end PlotSettings::redshiftToSource%4B7DC5EE0254.get
}

inline void PlotSettings::redshiftToSource (Real value)
{
  //## begin PlotSettings::redshiftToSource%4B7DC5EE0254.set preserve=no
  m_redshiftToSource = value;
  //## end PlotSettings::redshiftToSource%4B7DC5EE0254.set
}

inline std::map<int,PlotSettings::RebinInfo>& PlotSettings::groupsRebinInfo ()
{
  //## begin PlotSettings::groupsRebinInfo%4A9FE9A80253.get preserve=no
  return m_groupsRebinInfo;
  //## end PlotSettings::groupsRebinInfo%4A9FE9A80253.get
}

inline std::pair<int,PlotSettings::RebinInfo>& PlotSettings::lastRebinEntry ()
{
  //## begin PlotSettings::lastRebinEntry%4A9FEA0D0055.get preserve=no
  return m_lastRebinEntry;
  //## end PlotSettings::lastRebinEntry%4A9FEA0D0055.get
}

inline bool PlotSettings::splashPage () const
{
  //## begin PlotSettings::splashPage%4A9FEB1601B9.get preserve=no
  return m_splashPage;
  //## end PlotSettings::splashPage%4A9FEB1601B9.get
}

inline void PlotSettings::splashPage (bool value)
{
  //## begin PlotSettings::splashPage%4A9FEB1601B9.set preserve=no
  m_splashPage = value;
  //## end PlotSettings::splashPage%4A9FEB1601B9.set
}

inline bool PlotSettings::xLog () const
{
  //## begin PlotSettings::xLog%4A9FECC9037F.get preserve=no
  return m_xLog;
  //## end PlotSettings::xLog%4A9FECC9037F.get
}

inline void PlotSettings::xLog (bool value)
{
  //## begin PlotSettings::xLog%4A9FECC9037F.set preserve=no
  m_xLog = value;
  //## end PlotSettings::xLog%4A9FECC9037F.set
}

inline bool PlotSettings::yLog () const
{
  //## begin PlotSettings::yLog%4A9FECD203D0.get preserve=no
  return m_yLog;
  //## end PlotSettings::yLog%4A9FECD203D0.get
}

inline void PlotSettings::yLog (bool value)
{
  //## begin PlotSettings::yLog%4A9FECD203D0.set preserve=no
  m_yLog = value;
  //## end PlotSettings::yLog%4A9FECD203D0.set
}

inline void PlotSettings::energyUnit (const std::pair<string,std::pair<string,Real> >& value)
{
  //## begin PlotSettings::energyUnit%4AFDB29B0245.set preserve=no
  m_energyUnit = value;
  //## end PlotSettings::energyUnit%4AFDB29B0245.set
}

inline void PlotSettings::waveUnit (const std::pair<string,std::pair<string,Real> >& value)
{
  //## begin PlotSettings::waveUnit%4AFDB3340173.set preserve=no
  m_waveUnit = value;
  //## end PlotSettings::waveUnit%4AFDB3340173.set
}

inline bool PlotSettings::isWavePerHz () const
{
  //## begin PlotSettings::isWavePerHz%4B75BEF30309.get preserve=no
  return m_isWavePerHz;
  //## end PlotSettings::isWavePerHz%4B75BEF30309.get
}

inline void PlotSettings::isWavePerHz (bool value)
{
  //## begin PlotSettings::isWavePerHz%4B75BEF30309.set preserve=no
  m_isWavePerHz = value;
  //## end PlotSettings::isWavePerHz%4B75BEF30309.set
}

inline const SpecGroup& PlotSettings::spectra () const
{
  //## begin PlotSettings::spectra%4AB8F3F102AB.get preserve=no
  return m_spectra;
  //## end PlotSettings::spectra%4AB8F3F102AB.get
}

inline bool PlotSettings::isInteractive () const
{
  //## begin PlotSettings::isInteractive%4AC67325017F.get preserve=no
  return m_isInteractive;
  //## end PlotSettings::isInteractive%4AC67325017F.get
}

inline void PlotSettings::isInteractive (bool value)
{
  //## begin PlotSettings::isInteractive%4AC67325017F.set preserve=no
  m_isInteractive = value;
  //## end PlotSettings::isInteractive%4AC67325017F.set
}

inline const std::pair<PlotSettings::SaveArrayOption, int> PlotSettings::saveArrayInfo () const
{
  //## begin PlotSettings::saveArrayInfo%4ACA177B01BF.get preserve=no
  return m_saveArrayInfo;
  //## end PlotSettings::saveArrayInfo%4ACA177B01BF.get
}

inline void PlotSettings::saveArrayInfo (std::pair<PlotSettings::SaveArrayOption, int> value)
{
  //## begin PlotSettings::saveArrayInfo%4ACA177B01BF.set preserve=no
  m_saveArrayInfo = value;
  //## end PlotSettings::saveArrayInfo%4ACA177B01BF.set
}

inline std::map<string,string>& PlotSettings::labelNames ()
{
  //## begin PlotSettings::labelNames%4B01D6FD0330.get preserve=no
  return m_labelNames;
  //## end PlotSettings::labelNames%4B01D6FD0330.get
}

inline Real PlotSettings::badDataValue () const
{
  //## begin PlotSettings::badDataValue%4B1D57FE0236.get preserve=no
  return m_badDataValue;
  //## end PlotSettings::badDataValue%4B1D57FE0236.get
}

inline void PlotSettings::badDataValue (Real value)
{
  //## begin PlotSettings::badDataValue%4B1D57FE0236.set preserve=no
  m_badDataValue = value;
  //## end PlotSettings::badDataValue%4B1D57FE0236.set
}

//## begin module%4A9D598900B8.epilog preserve=yes
//## end module%4A9D598900B8.epilog


#endif
